Motorola ElfPack 1.0 SDK
========================

This package for Linux platform contains the following tools:

* ARM C/C++ Compiler, ADS1.2 [Build 848] for compiling source code.
* SDK header files by Andy51, G-XaD, and other developers from MotoFan.Ru forum.

## Install

Unpack archive and copy all files to `/opt/arm` directory, then add `/opt/arm/bin` catalog to `$PATH` environment variable.

```sh
sudo tar -xvzf *.tgz -C /opt
echo 'PATH=$PATH:/opt/arm/bin' >> ~/.bashrc
```

## Usage SDK

Set proper paths to ADS compiler, libraries and SDK headers in `Makefile` build script.

```sh
$ make clean
$ make
```

## Authors

Andy51, G-XaD, om2804, kadukmm, etc.

## Additional Information

[ELFs developing and porting](https://forum.motofan.ru/index.php?showforum=184)

© MotoFan.Ru, 2007-2022.
