#ifndef WEATHER_API_H
#define WEATHER_API_H

#include <typedefs.h>
#include <events.h>

//   
// www.gismeteo.ru

#define WEATHER_MGR_MAIN_REGISTER	0xFF14

#define WeatherReqAPI(add_data) \
		AFW_CreateInternalQueuedEvAuxD(WEATHER_MGR_MAIN_REGISTER,&add_data,FBF_LEAVE,0,NULL);

typedef UINT32 Weather_getForecast_f(WCHAR *buf, UINT8 num); // num=1...4 -   
typedef UINT32 Weather_getTemperature_f(WCHAR *buf, UINT8 num);
typedef UINT32 Weather_getPhenomena_f(WCHAR *buf, UINT8 num);
typedef UINT32 Weather_getWind_f(WCHAR *buf, UINT8 num);

#endif
