#ifndef SDK_DL_H
#define SDK_DL_H

#include <typedefs.h>

#define KEY_0       0
#define KEY_1       1
#define KEY_2       2
#define KEY_3       3
#define KEY_4       4
#define KEY_5       5
#define KEY_6       6
#define KEY_7       7
#define KEY_8       8
#define KEY_9       9
#define KEY_STAR    10
#define KEY_POUND   11

#define KEY_SOFT_LEFT	0x0E//14
#define KEY_SOFT_RIGHT	0x0F//15

#define KEY_RED     17
#define KEY_GREEN   18

#define KEY_MENU    20
#define KEY_SMART   21

#define KEY_VOLUP   23
#define KEY_VOLDOWN 24

#define KEY_UP      44
#define KEY_DOWN    45
#define KEY_LEFT    46
#define KEY_RIGHT   47
#define KEY_OK		0x3D//61
#define KEY_JOY_OK		0x3D//61

//#define KEY_SMART   0x15//21
#define KEY_CAM     0x3F//63

UINT32 DL_AudPlayTone( UINT32 tone,  UINT8 volume ); //Current volume = 0xFF

				/* ߧܧ?ѧۧާ֧?- ߧ ӧ֧֧?*/

/* ԧ?ѧۧާ֧ ѧҧѧӧѧ?  ٧էѧ?ڧӧ֧?EV_TIMER_EXPIRED, attachment ܧԧ ܧѧ٧ӧѧ?ߧ DL_TIMER_DATA_T */

typedef struct
{
	UINT32		time;
	UINT32		ID;
} DL_TIMER_DATA_T;

/*  ѧڧ?ѧۧާ֧, ܧ?ѧҧѧ?֧?time ާ */
UINT32 APP_UtilStartTimer( UINT32 time,  UINT32 ID,  void *app ); // ID ҧէ??DL_TIMER_DATA_T ?ҧѧҧ?ڧӧ֧ߧ

/*  ѧڧ?ѧۧާ֧, ܧ?ҧէ?ѧҧѧӧѧ ֧?ܧѧاէ time ާ */
UINT32 APP_UtilStartCyclicalTimer( UINT32 time,  UINT32 ID,  void *app );

/* ѧߧӧڧ ѧۧާ֧ */
UINT32 APP_UtilStopTimer( void *app );

///////////////////// Added by om2804 //////////////////////

/* ֧ԧݧڧӧ?ܧ էڧݧ֧ 

	E398 ONLY! */
void HAPI_LP393X_disp_backlight_intensity( UINT32 light ); // light = 0..100

/* ܧӧ?ӧ֧էڧէ ?ߧѧ?
	type: 0-ҧܧӧ? 1-ߧѧ?
	val: 0xRGB (0x000 - 0xFFF), ߧѧڧާ֧ 0x00E - ڧߧ?

	E398 ONLY! */
void HAPI_LP393X_set_tri_color_led( UINT32 type,  UINT32 val );

/////////////////// Added by WhiteHotIce /////////////////////

/* ߧܧڧ ֧ҧ */
void HAPI_WATCHDOG_soft_reset( void );

/* ߧܧڧ ӧܧݧ֧? */
//void pu_main_powerdown( void );
void pu_main_powerdown(UINT32 r0);

///////////////////// Added by G-XaD ///////////////////////

/* ڧѧ֧ ?ҧ?seem_data count ҧѧۧ ڧާ seem, ٧ѧڧ record
	֧?֧ߧڧ??ӧէ֧ݧڧ ߧ ާ֧ߧ?count ҧѧۧ ?! */
UINT32 SEEM_FDI_OUTSIDE_SEEM_ACCESS_read( UINT32 seem,  UINT32 record,  void* seem_data,  UINT32 count );

/* ѧڧӧѧ֧ ڧ ҧ֧ seem_data count ҧѧۧ ??seem, ٧ѧڧ record
	 ӧ֧֧?*/
#define SEEM_WRITE_METHOD_ADD				0
#define SEEM_WRITE_METHOD_UPDATE			1
UINT32 SEEM_FDI_OUTSIDE_SEEM_ACCESS_write( UINT32 method,  UINT32 seem,  UINT32 record,  void* seem_data,  UINT32 count );
/* ާѧڧӧѧߧߧ?ӧӧ?ܧ format ߧ ܧާ (ڧѧ֧? ?ާ?MidWay)
	 ߧܧڧ֧ ݧԧڧ֧? ӧ */
void PFprintf( char* format, ... ); // %d %x %s, a-la printf


/* ѧѧ ާڧԧѧݧ?funlight) ?ߧާ֧?fl_id
	 ?ڧӧܧ ߧܧڧ ?էߧ?ާ֧?ӧݧߧ֧? ?p2 = 3,
	 ߧ ߧ ֧ѧ ?ڧӧէڧ ?ѧߧ?էڧݧ֧ (ߧѧӧ֧ߧ ӧ٧ާاߧ?ڧ...) 

	 E398 ONLY! */
UINT32 DL_AudStartFunlight( UINT8 fl_id,  UINT32 p2,  UINT32 p3 ); // p2 = 1, p3 = 0

/* ѧߧѧӧݧڧӧѧ?ާڧԧѧݧ?funlight) ?ߧާ֧?fl_id 

	E398 ONLY! */
UINT32 DL_AudStopFunlight( UINT8 fl_id );

/* ܧݧڧ?էڧ֧ */
void DAL_DisableDisplay( UINT32 p1 ); // p1 = 0

/* ܧݧڧ էڧ֧ */
void DAL_EnableDisplay( UINT32 p1 ); // p1 = 0
  typedef struct
{
    UINT8     day;
    UINT8     month;
    UINT16    year;
} CLK_DATE_T;




UINT32 DL_ClkGetDate(CLK_DATE_T*);

UINT32 DL_ClkGetTime(UINT8* time);

UINT32 MME_GC_playback_open_audio_play_forget(WCHAR* filename );

////////////////////////////////////////////////////////
void DL_KeyInjectKeyPress(UINT8 p1,UINT8 p2,UINT8 p3);

void p_key(UINT8 key)
{
  DL_KeyInjectKeyPress(key,0,0);
  DL_KeyInjectKeyPress(key,1,0);
}
//////////////////////////////////////////////////

extern const UINT32 *KEYPAD_STATE;
#define DB_FEATURE_KEYPAD_STATE		*KEYPAD_STATE

BOOL DL_DbFeatureGetCurrentState( UINT16 fstate_ID, UINT8 *result );

UINT32 DL_DbFeatureStoreState(UINT16 fstate_ID, UINT8 state);

// fstate_ID??offset in the base  
// state ??written value

typedef struct
{
    WCHAR            *url;           
    UINT32           unk;    
} UIS_SETWALLPAPER_SETTINGS_T;

UINT32 UIS_SetWallpaper(UIS_SETWALLPAPER_SETTINGS_T * );

UINT32 DL_AudSetVolumeSetting(UINT8 volume_type,UINT8 volume);

UINT32 DL_AudGetVolumeSetting(UINT8 volume_type,UINT8 *volume);

//UINT32 DL_SigRegQuerySignalStrength(UINT32 * Strength);

UINT32 DL_ClkGetClock(UINT32 * clock);

UINT32 DL_DbFeatureStoreBlock(UINT32 MN,UINT16 *ID,UINT32 P3); 

//UINT32 DL_FsGetIDFromURI(WCHAR* url,UINT16 *ID);

UINT8 HAPI_ATOD_convert_ambient_light_sensor( void );

UINT8 DRM_GetCurrentLanguage(UINT8 * LGID);

UINT32 DL_DbSigNamGetSecurityCode(WCHAR *);

UINT32 DL_DbSigNamGetUnlockCode(WCHAR *);

UINT8 DL_DbFeatureGetValueString(UINT32 feature_id, WCHAR *feature_string );//Reading lines from base

void DL_KeyUpdateKeypadBacklight( UINT8 P1 );//P1=1 ƣP2=0

UINT32 UIS_SetBacklightWithIntensity(UINT8 P1,  UINT8 P2);
//P1=255
//P2=0ʱرձ
//P2=1ʱ P2Ϊ

UINT32 AFW_CreateInternalQueuedEvAux (UINT32 ev_id, UINT32 flags, UINT32 att_size, void * att_data); // flags = 0x64, 0x65; att_zise = 0; att_data = 0; ev_id? NKZKV? Yu? Vl; 

UINT8 DL_PwrGetActiveBatteryPercent( void );

typedef struct {
	UINT8	percent;
	UINT8	unk1;
} DL_SIG_SIGNAL_STRENGTH_T;

BOOL DL_SigRegQuerySignalStrength( DL_SIG_SIGNAL_STRENGTH_T * );

//UINT32 UIS_SetActionList(UIS_DIALOG_T dialog, ACTIONS_T *action_list);

//UINT32 UIS_SetCenterSelectAction (UIS_DIALOG_T dialog, EVENT_CODE_T center_select_action);

////////////////////

#define AUDIO_STATUS 	0x69
#define GPRS_STATUS		0x1D
#define Network_STATUS  0x27


typedef UINT8 STATUS_ID;

extern const UINT8 *ITUNES_STATUS;
#define ITUNES_STATE_STATUS		*(ITUNES_STATUS+1) //79 - 152. 49R,70R - 149. Lte2 - 150 // integer: 0 - no, 1 - play, 2 - pause

typedef union
{
    INT32                            integer;
    BOOL                             boolean;
    WCHAR                            *currency;
    WCHAR                            *quoted_name;
    WCHAR                            *quoted_phone_number;
    WCHAR                            *quoted_string;
    UINT32                      	 phone_type;
} STATUS;

UINT32 UIS_SetStatus(STATUS_ID status_id, STATUS value);
UINT32 UIS_GetCurrentStatusValue(STATUS_ID status_id,  STATUS *value); 
////////////////////////////////


#define MAX_CALLS                   7

typedef UINT8 CALL_OVERALL;
typedef UINT8 CALL_STATE;
typedef UINT16  CALL_ID;

typedef struct
{       
    CALL_ID                call_id;  
   CALL_STATE             call_state;
} CALL_ID_T;

typedef struct
{
    UINT8  number_of_calls;
    CALL_OVERALL overall_call_state;
    CALL_ID_T call_state_info[MAX_CALLS];
} CALL_STATES;


//number_of_calls == 0 ûҪ

void DL_SigCallGetCallStates(CALL_STATES *call_states);



///////////////////////////////

BOOL APP_MMC_Util_IsVoiceCall(void); 

/* Get the system time in the teak */ 

UINT64 suPalReadTime (void); 
/*Translate time of the ticks in milliseconds*/ 

UINT64 suPalTicksToMsec (UINT64 ticks);

////////////////////////////


#define DialogType_Phonebook 0x28
#define DialogType_Dialling              0x05//Ŵ
#define DialogType_EnterName             0x08//Ƶȡ
#define DialogType_SetDate               0x0B//
#define DialogType_SetTime               0x0D//ʱ
#define DialogType_Homescreen            0x0E//
#define DialogType_list                  0x10//бĿ
#define DialogType_SelectionList         0x13//ѡ翪ر֮ࡣ
#define DialogType_BatteryandMemory      0x15//ϢڴʹʵʾĴ
#define DialogType_JumpOut               0x17//ڣ"밴XX","ȴ"֮
#define DialogType_MessageBox            0x1B//Ϣռ䣬䣬ݸ
#define DialogType_GameAni               0x1D//ϷӦóʱʾĶ
#define DialogType_WapMenu               0x1E//Wapز˵
#define DialogType_VideoCamera           0x25//ȡ
#define DialogType_Password              0x26//Ĵ
#define DialogType_PB_SC_Other           0x28//绰ݼ֮࣬кܶ඼״̬
#define DialogType_Menu                  0x2D//˵
#define DialogType_SecondLevelMenu       0x2E//˵˵
#define DialogType_WriteText             0x32//Ϣı
#define DialogType_Brightness            0x37//ãȣڸ
#define DialogType_Picture               0x39//ý壭ͼƬ

UINT32 UIS_GetActiveDialogType(UINT8* res);

///////////////////////////////

extern const UINT32 *CALL_ALERT; 
//UINT32 event = *CALL_ALERT;

//////////////////////////////////

extern const UINT16 *ALMCLK_REMINDER_START;
//UINT32 event = *ALMCLK_REMINDER_START;

/////////////////////////

extern const UINT32 *DATEBOOK_REMINDER;
//UINT32 event = *DATEBOOK_REMINDER;

/*

extern const UINT32 *SEEM_IMEI;
WCHAR IMEI[15];
DL_DbFeatureGetValueString(*SEEM_IMEI, IMEI );

*/


/*******************************
ת
*******************************/


UINT16 DL_Char_convUCS2toUTF8String( const WCHAR * source_ptr,
											UINT16 source_len,
											UINT8 * target_ptr,
											UINT16 target_buf_len); 

WCHAR DL_Char_convUTF8toUCS2String(const char * source_ptr,
											UINT16 source_len, 
											WCHAR * target_ptr, 
											UINT16 target_buf_len);

//GB2312תUNICODE ()

WCHAR DL_Char_convGB2312toUCS2Buf( const char * source_ptr,
											UINT16 source_len,
											WCHAR * target_ptr,
											UINT16 target_buf_len);

//big5תUNICODE ()

WCHAR DL_Char_convBig5toUCS2Buf( const char * source_ptr,
											UINT16 source_len,
											WCHAR * target_ptr,
											UINT16 target_buf_len);
////////////////////////////////////////////////////

// Cell Id
void DL_SigRegGetCellID(UINT16 *cell_id);


/*******************************

*******************************/

typedef struct
{
	WCHAR  address[51];
	UINT8  addr_type; // 0 -SMS, 1 - EMAIL, 2 - No, 3 - Long Msg ??? 
	WCHAR  contents[512]; //ߴ0x7bfe ֻΪţΪһܶ
} SEND_TEXT_MESSAGE_T;

UINT32 DL_SigMsgSendTextMsgReq(IFACE_DATA_T *port, SEND_TEXT_MESSAGE_T *msg_ptr);

/******************************** 
   Tags 
*********************************/ 
// Non! 

#define SC_TYPE_URL 5 
#define SC_TYPE_APP 6 

typedef UINT8 SC_TYPE_T; 

typedef struct 
{
     UINT8 seem_rec; // seem_rec-1 
     UINT8 type; // type tags 
     UINT8 index; // number on the list, counting from 1. Number tags 
     UINT8 unk1; // 0xFE 
     UINT32 ev_code; 
     UINT32 list_index; // id dedicated item list 
     UINT32 param1; 
	 UINT32 list2_index; // also some id item 
     UINT32 param2; 
     UINT32 data; // used for a pointer to data such as URL-pointer to address 
     UINT32 lang_text; // RESOURCE_ID 
     WCHAR text [17];// name tags 
     UINT16 unk2; // 0xffbd 
     
} SEEM_0002_T; 


// Create tags 
UINT8 DL_DbShortcutCreateRecord (IFACE_DATA_T * data, SEEM_0002_T record); 

// Update tags 
UINT8 DL_DbShortcutUpdateRecord (IFACE_DATA_T * data, SEEM_0002_T record); 

// Remove tags 
UINT8 DL_DbShortcutDeleteRecord (IFACE_DATA_T * data, UINT8 seem_rec); 

// Checks recordId, 0 - no error 
UINT8 DL_DbShortcutGetRecordByRecordId (IFACE_DATA_T * data, UINT8 seem_rec); 

// Receives record number available 
UINT16 DL_DbShortcutGetNumOfRecordsAvailable (void); 

// Receives record number used 
UINT16 DL_DbShortcutGetNumOfRecordsUsed (BOOL voice_shortcut); 

// Receives the first available room 
UINT8 DL_DbGetFirstAvailableNumber (void); 

// Receives record number used by URL 
UINT16 DL_DbShortcutGetNumOfURLRecordsUsed (void); 

// Checks URLId, 0 - no error 
UINT32 DL_DbShortcutGetURLByURLId (IFACE_DATA_T * data, UINT32 URLId); 

// Get the type of list 
SC_TYPE_T DL_DbShortcutGetshortcutType (UINT8 index); 

// Receives record number accessible URL 
UINT16 DL_DbShortcutGetNumOfURLRecordsAvailable (void); 


#endif
