#ifndef MEMORY_H
#define MEMORY_H

#include <typedefs.h>

#ifdef __cplusplus
extern "C" {
#endif


//    
void *suAllocMem( UINT32 size, INT32 *result ); //result can be NULL
void suFreeMem( void *ptr );
void suSleep(int time, INT32 *result); //  


#define malloc(sz)		suAllocMem(sz, NULL)
#define mfree(sz)		suFreeMem(sz)



#define free(p) { \
if(p) { \
suFreeMem(p); \
p=NULL; \
} \
}


void __rt_memclr( void *, UINT32 size );						//    
#define memclr(m,s)		__rt_memclr((void *)m,(UINT32)s)

void * __rt_memcpy(void *dest,const void *source,int cnt);		//   
#define memcpy(dst,src,sz)		__rt_memcpy((void *)dst,(const void *)src,(int)sz)

void * __rt_memset( void *, int, UINT32 size );				//     
//void *memset(void *s, int c, UINT32 n); //   s  n  c
#define memset(m,v,sz)		__rt_memset((void *)m,(int)v,(UINT32)sz)


#ifdef __cplusplus
} /* extern "C" */
#endif


#endif 