#ifndef BLUETOOTH_H
#define BLUETOOTH_H

#include <typedefs.h>
#include <time_date.h>
#include <filesystem.h>

#ifdef __cplusplus
extern "C" {
#endif

//    Bluetooth
extern const UINT32 *EVENT_BT;
#define EV_BT_SEND				*EVENT_BT

//       Bluetooth  wap
extern const UINT32 *EV_PREVIEW_START; //   PREVIEW_RECORD_T
#define EV_START_PREVIEW		*EV_PREVIEW_START



typedef struct {
    WCHAR               name[FILEURI_MAX_LEN+1];  //           
    WCHAR               temp_name[80]; //    
    UINT8				unk1;
    char				*type; //  
    BOOL                unk2;
    UINT32              size;  //   
    CLK_DATE_T          date_stamp; //  
    CLK_TIME_T          time_stamp; // 
    UINT8   			unk3;
    UINT32         		unk4[2];
    UINT32              offset; //    ,    
    FILE_HANDLE_REFERENCE_T  	file_reference; //   EMS
    BOOL                unk5;
    UINT32              unk6[2];
    void                *p_buffer; //   
    INT32               unk7;
    UINT8               unk8[2];
} PREVIEW_RECORD_T;


#ifdef __cplusplus
} /* extern "C" */
#endif

#endif