#ifndef RES_DEF_H
#define RES_DEF_H

// -----------------------------------------------------------------------------------------
// RES_TYPE_GRAPHICS

#define RES_GIF_FOLDER				0x120000CE
#define RES_GIF_FILE_VIDEO			0x120000D5
#define RES_GIF_FILE_AUDIO			0x120000CD
#define RES_GIF_FILE_IMAGE			0x120000CF
#define RES_GIF_SELECTED			0x120000CC

#define RES_GIF_ICQ_ONLINE_STATUS	0x1200059A

#define RES_GIF_IMAGE_BIG			(0x12000000 | 474)
#define RES_GIF_IMAGE_BIG_2			(0x12000000 | 475)
#define RES_GIF_NEW_IMAGE			(0x12000000 | 477)
#define RES_GIF_NEW_ALBUM			(0x12000000 | 478)

#define RES_GIF_ARROW				(0x12000000 | 1429)
#define RES_GIF_2_ARROWS			(0x12000000 | 1497)


// -----------------------------------------------------------------------------------------
// RES_TYPE_STRING

#define LANG_EXIT					0x01000A64	// Exit
#define LANG_DELETE					0x010009D6	// Delete
#define LANG_COPY					0x010009E1	// Copy
#define LANG_CUT					0x010009E2	// Cut
#define LANG_BLUETOOTH				0x01000F66	// Bluetooth
#define LANG_ADD					0x01000DDC
#define LANG_ACT_RENAME				0x01000877
#define LANG_ABOUT					0x01000898	// " ..."
#define LANG_AUTHOR					0x01000ADF	// ""
#define LANG_AUTHOR_				0x01000B28	// ":"
#define LANG_VERSION				0x0100071D	// ""
#define LANG_VERSION_				0x01000809	// ":"
#define LANG_TIME_					0x0100080A	// ":"
#define LANG_IP_					0x01001817	// "IP:"
#define LANG_NAME_					0x010007B9	// ":"
#define LANG_NAME					0x010000DB	// ""
#define LANG_FOLDER					0x01000D43	// ""
#define LANG_YES					0x0100016A
#define LANG_NO						0x010000E6
#define LANG_EDIT					0x01000D8C
#define LANG_SAVE					0x01000375
#define LANG_SAVE_AS				0x01000AD8
#define LANG_DELETED				0x010007A1
#define LANG_DELETED_				0x01000267

#define LANG_DELETING				0x01000ACF

#define LANG_FILE_TYPE_				0x01000A48	// " :"
#define LANG_FILE_SIZE_				0x01000A49	// " :"
#define LANG_TYPE					0x01000157	// ""
#define LANG_SIZE					0x0100087D	// ""
#define LANG_SIZE_					0x01000808	// ":"
#define LANG_FREE_					0x01000B03	// ":"
#define LANG_MEMORY_CARD			0x0100152D	// "Memory Card"
#define LANG_PHONE_MEMORY			0x010000F9	//
#define LANG_USED_					0x01000B14	// "Used:"
#define LANG_TOTAL_					0x01000B10	// "Total:"
#define LANG_SPACE					0x01000DD2
#define LANG__NONE_					0x01000874	// "(None)"
#define LANG_BYTE					0x0100080C	// ""
#define LANG_GROUP					0x010015B0	// "Group"

#define LANG_COPYED					0x010009E5	// ""
#define LANG_CUTED					0x010009E6	// ""
#define LANG_BEGIN					0x010009F0	// 
#define LANG_FILENAME				0x0100086F
#define LANG_AUDIO					0x01000DAC
#define LANG_MEDIA					0x01000DAD
#define LANG_VIDEO					0x01000DB0
#define LANG_MOVE1					0x01000D59 // 
#define LANG_COPY1					0x010001C4 //
#define LANG_DEL1					0x01000078 //
#define LANG_FILES					0x01001160 // ()
#define LANG_STORE					0x01000211
#define LANG_MENU					0x01000BCB

#define LANG_ICQ					0x01001596
#define LANG_ICQ_NUMBER				0x01001597
#define LANG_OFF_SETTINGS			0x0100137C
#define LANG_PASS_WORD				0x010000F5
#define LANG_PASS_WORD_				0x010004B5

#define LANG_START					0x01001283

#define LANG_SETTINGS				0x01000129 // ""

#define LANG_ERROR					0x010004B8
#define LANG_APP_ERROR				0x010004B1

#define LANG_CONNECT				0x0100136F
#define LANG_DISCONNECT				0x01001370
#define LANG_CONNECTING				0x01001372
#define LANG_STATE					0x01001375

#define LANG_ICQ_NUMBER				0x01001597
#define LANG_CODE_					0x01000E9E // ":"
#define LANG_WRONG_PW				0x01000BC7

#define LANG_ALL_SELECTED_FILES		0x01000B38

#define LANG_TYPE_					0x01000B11

#define LANG_FOLDER_				0x01000A14

#define LANG_SHOW					0x0100007D

#define LANG_BACK					0x01001927

#define LANG_BOOKMARKS				0x0100113C
#define LANG_BOOKMARKS_FOOL			0x01001497
#define LANG_ADD_BOOKMARK			0x010007DE

#define LANG_EMPTY					0x01000398

#define LANG_NO_CONTENT				0x01000996

#define LANG_FOR_					0x0100057B

#define LANG_RELOCATE_TO			0x01000583

#define LANG_ADDED					0x01000C89

#define LANG_QUOTATION_MARK			0x010004D9

#define LANG_NOT_SUPPORTED			0x0100028A

#define LANG_DONE					0x01000A0D
#define LANG_DONE_					0x01000A1E

#define LANG_LOADING___				0x01000A28
#define LANG_PAUSE					0x01000A2A
#define LANG_STOP					0x01000A2B
#define LANG_LIST					0x01000A38

// 19B1 & >
#ifdef FTR_L7E
#define LANG_PROPERTIES				0x01001CD8
#define LANG_FILETYPE				0x01001CDF
#define LANG_WRONG_UIN_PW			0x01001F23
#define LANG_WRONG_UIN				0x010019B2
#define LANG_DISCONNECTED_BY_ICQ	0x010019D7
#else
#define LANG_HIDDEN					0x01001E20
#define LANG_CLOSE					0x01001CBB
#define LANG_PROPERTIES				0x01001CED
#define LANG_FILETYPE				0x01001CC2
#define LANG_WRONG_UIN_PW			0x01001D68
#define LANG_DISCONNECTED_BY_ICQ	0x010019BB
#endif


// -----------------------------------------------------------------------------------------
// RES_TYPE_ACTION

// 0x0600yyyy										// soft/list
#define RES_ACTION_BACK				0x06000001	// 11
#define RES_ACTION_CALL				0x06000002	// 11
#define RES_ACTION_CALLBACK			0x06000003	// 01
#define RES_ACTION_CANCEL			0x06000004	// 11
#define RES_ACTION_CHANGE			0x06000005	// 11
#define RES_ACTION_CLEANUP_ALL		0x06000006	// 01
#define RES_ACTION_CNF_NEW			0x06000007	// 10
#define RES_ACTION_CONFIRM_NO		0x06000008	// 11
#define RES_ACTION_CONFIRM_YES		0x06000009	// 11
#define RES_ACTION_DELETE			0x0600000A	// 01
#define RES_ACTION_EDIT				0x0600000B	// 01
#define RES_ACTION_SETTING			0x0600000C	// 01
#define RES_ACTION_DELETE2			0x0600000D	// 11
#define RES_ACTION_DELETE_ALL		0x0600000E	// 01
#define RES_ACTION_DELETE3			0x0600000F	// 10

#define RES_ACTION_SAVE				0x06000018	// 11
#define RES_ACTION_DONE				0x06000019	// 11	// to left_soft
#define RES_ACTION_EDIT_1			0x0600001A	// 11
#define RES_ACTION_OK				0x0600001D	// 11


// -----------------------------------------------------------------------------------------
// RES_TYPE_FIELD

#define RES_FIELD_NUMBER			0x0D00001A
#define RES_FIELD_PASS_WORD			0x0D0001AD
#define RES_FIELD_VOLUME			0x0D0002E2
#define RES_FIELD_NAME				0x0D00019B




#endif	// RES_DEF_H